//Leek
datablock AudioProfile(LeekIntroAudio) {
   fileName = "./intro.wav";
   description = "AudioDefaultLooping3d";
   preload = "1";
   uiName = "Levan Intro";
};
datablock AudioProfile(LeekChorusAudio) {
   fileName = "./chorus.wav";
   description = "AudioDefaultLooping3d";
   preload = "1";
   uiName = "Levan Chorus";
};
datablock ProjectileData(MikuLeekProjectile)
{
   directDamage=0;
   uiname="";
};
datablock ItemData(MikuLeekItem:HammerItem)
{
   uiname = "Leek";
   image = MikuLeekImage;
   iconName="./icon_leek";
   colorShiftColor="0.6 0.9 0.6 1";
   shapeFile="./leekModel.dts";
};
datablock ShapeBaseImageData(MikuLeekImage:HammerImage)
{
   projectile=MikuLeekProjectile;
   shapeFile="./leekModel.dts";
   eyeOffset = "";
   showBricks=0;
   eyeRotation = "";
   rotation=eulerToMatrix("90 0 90");
   colorShiftColor="0.6 0.9 0.6 1";
   stateSequence[3] = "";
   stateSequence[5] = "";
};
function MikuLeekImage::onMount(%this,%obj,%slot)
{
   Parent::onMount(%this,%obj,%slot);
   %obj.playAudio(0,nameToID(LeekIntroAudio));
}
function MikuLeekImage::onUnMount(%this,%obj,%slot)
{
   Parent::onUnMount(%this,%obj,%slot);
   %obj.stopAudio(0);
}

function MikuLeekImage::onFire(%this, %obj, %slot)
{
	Parent::onFire(%this, %obj, %slot);
	%obj.playAudio(0,nameToID(LeekChorusAudio));
	%mask = $TypeMasks::StaticObjectType | $TypeMasks::PlayerObjectType;
	%ray=containerRaycast(%obj.getEyePoint(),vectorAdd(%obj.getEyePoint(),vectorScale(%obj.getMuzzleVector(0),3)),%mask,%obj);
	%col=getWord(%ray,0);
	if(isObject(%col))
	{
	   if(%col.getType() & $TypeMasks::PlayerObjectType)
	   {
	      if(minigameCanDamage(%obj.client,%col) && minigameCanDamage(%col.client,%obj) && getMinigameFromObject(%obj)==getMinigameFromObject(%col) && isObject(getMinigameFromObject(%obj)))
	         %col.addVelocity(vectorAdd(vectorScale(%obj.getMuzzleVector(0),50),"0 0 3"));
	   }
	}
	%obj.playthread(2, rotCW);
}

function MikuLeekImage::onStopFire(%this, %obj, %slot)
{	
	%obj.playthread(2, root);
	%obj.playAudio(0,nameToID(LeekIntroAudio));
}


//Vegetable Juice

datablock ShapeBaseImageData(TomatoVegetableHeadImage)
{
	shapeFile = "./tomato.dts";
	emap = true;
	mountPoint = 5;
	offset = "0 0 0";
	eyeoffset = "0 0 -100";
	rotation = eulerToMatrix( "0 0 0" );
	doColorShift = true;
	colorShiftColor = "0.9 0 0 1";
};
datablock ShapeBaseImageData(LemonVegetableHeadImage : TomatoVegetableHeadImage)
{
   eyeoffset = "0 0 -100";
   shapeFile = "./lemon.dts";
   colorShiftColor = "0.9 0.9 0 1";
};
datablock ShapeBaseImageData(BananaVegetableHeadImage : TomatoVegetableHeadImage)
{
   eyeoffset = "0 0 -100";
   shapeFile = "./banana.dts";
   colorShiftColor = "0.7 0.7 0 1";
};
datablock ShapeBaseImageData(EggplantVegetableHeadImage : TomatoVegetableHeadImage)
{
   eyeoffset = "0 0 -100";
   shapeFile = "./Eggplant.dts";
   colorShiftColor = "0.6 0 0.6 1";
};
function VegetableRandom()
{
   switch(getRandom(0,3))
   {
      case 0 : return TomatoVegetableHeadImage;
      case 1 : return LemonVegetableHeadImage;
      case 2 : return BananaVegetableHeadImage;
      case 3 : return EggplantVegetableHeadImage;
      default : return EggplantVegetableHeadImage;
   }
}
datablock AudioProfile(PoPiPoAudio) {
   fileName = "./popipo.wav";
   description = "AudioDefaultLooping3d";
   preload = "1";
   uiName = "Popipo";
};
datablock AudioProfile(VegetableJuiceFireSound) {
   fileName = "./eeeee.wav";
   description = "AudioClosest3d";
   preload = "1";
};
datablock ItemData(VegetableJuiceItem : PrintGun)
{
   uiname = "Vegetable Juice";
   shapeFile = "./bottle.dts";
   colorShiftColor="0 0.5 0 1";
   iconName="./icon_juice";
   image = vegetableJuiceImage;
};
datablock ShapeBaseImageData(VegetableJuiceImage : PrintGunImage)
{
   offset="0 0.1 -0.35";
   showBricks=0;
   eyeRotation = eulerToMatrix("0 0 180");
   shapeFile=VegetableJuiceItem.shapeFile;
   colorShiftColor=VegetableJuiceItem.colorShiftColor;
   stateSound[2] = "";
   stateEmitter[2] = "";
};
function VegetableJuiceImage::onFire(%this,%obj,%slot)
{
   %obj.stopAudio(0);
   %obj.tool[%obj.currTool]=0;
   if(isObject(%obj.client))
      messageClient(%obj.client,'MsgItemPickup','',%obj.currTool,0);
   %obj.updateArm(0);
   %obj.unMountImage(0);
   %obj.unMountImage(2);
   serverPlay3d(VegetableJuiceFireSound,%obj.getTransform());
   %obj.mountImage(VegetableRandom(),2);
   %obj.hideHead();
}
function VegetableJuiceImage::onMount(%this,%obj,%slot)
{
   Parent::onMount(%this,%obj,%slot);
   %obj.playAudio(0,nameToID(PoPiPoAudio));
}
function VegetableJuiceImage::onUnMount(%this,%obj,%slot)
{
   Parent::onUnMount(%this,%obj,%slot);
   %obj.stopAudio(0);
}
datablock ItemData(TomatoVegetableJuiceItem:VegetableJuiceItem)
{
   uiname="Vegetable Juice (Tomato)";
   colorShiftColor = "0.9 0 0 1";
   image = TomatoVegetableJuiceImage;
};
datablock ShapeBaseImageData(TomatoVegetableJuiceImage:VegetableJuiceImage)
{
   colorshiftColor=TomatoVegetableJuiceItem.colorShiftColor;
};
function TomatoVegetableJuiceImage::onFire(%this,%obj,%slot)
{
   %obj.stopAudio(0);
   %obj.tool[%obj.currTool]=0;
   if(isObject(%obj.client))
      messageClient(%obj.client,'MsgItemPickup','',%obj.currTool,0);
   %obj.updateArm(0);
   %obj.unMountImage(0);
   %obj.unMountImage(2);
   serverPlay3d(VegetableJuiceFireSound,%obj.getTransform());
   %obj.mountImage(TomatoVegetableHeadImage,2);
   %obj.hideHead();
}
function TomatoVegetableJuiceImage::onMount(%this,%obj,%slot)
{
   VegetableJuiceImage::onMount(%this,%obj,%slot);
}
function TomatoVegetableJuiceImage::onUnMount(%this,%obj,%slot)
{
   VegetableJuiceImage::onUnMount(%this,%obj,%slot);
}
datablock ItemData(EggplantVegetableJuiceItem:VegetableJuiceItem)
{
   uiname="Vegetable Juice (Eggplant)";
   colorShiftColor = "0.6 0 0.6 1";
   image = EggplantVegetableJuiceImage;
};
datablock ShapeBaseImageData(EggplantVegetableJuiceImage:VegetableJuiceImage)
{
   colorshiftColor=EggplantVegetableJuiceItem.colorShiftColor;
};
function EggplantVegetableJuiceImage::onFire(%this,%obj,%slot)
{
   %obj.stopAudio(0);
   %obj.tool[%obj.currTool]=0;
   if(isObject(%obj.client))
      messageClient(%obj.client,'MsgItemPickup','',%obj.currTool,0);
   %obj.updateArm(0);
   %obj.unMountImage(0);
   %obj.unMountImage(2);
   serverPlay3d(VegetableJuiceFireSound,%obj.getTransform());
   %obj.mountImage(EggplantVegetableHeadImage,2);
   %obj.hideHead();
}
function EggplantVegetableJuiceImage::onMount(%this,%obj,%slot)
{
   VegetableJuiceImage::onMount(%this,%obj,%slot);
}
function EggplantVegetableJuiceImage::onUnMount(%this,%obj,%slot)
{
   VegetableJuiceImage::onUnMount(%this,%obj,%slot);
}
datablock ItemData(YellowVegetableJuiceItem:VegetableJuiceItem)
{
   uiname="Vegetable Juice (Yellow)";
   colorShiftColor = "0.9 0.9 0 1";
   image = YellowVegetableJuiceImage;
};
datablock ShapeBaseImageData(YellowVegetableJuiceImage:VegetableJuiceImage)
{
   colorshiftColor=YellowVegetableJuiceItem.colorShiftColor;
};
function YellowVegetableJuiceImage::onFire(%this,%obj,%slot)
{
   %obj.stopAudio(0);
   %obj.tool[%obj.currTool]=0;
   if(isObject(%obj.client))
      messageClient(%obj.client,'MsgItemPickup','',%obj.currTool,0);
   %obj.updateArm(0);
   %obj.unMountImage(0);
   %obj.unMountImage(2);
   serverPlay3d(VegetableJuiceFireSound,%obj.getTransform());
   %obj.mountImage((getRandom(0,1)?LemonVegetableHeadImage:BananaVegetableHeadImage),2);
   %obj.hideHead();
}
function YellowVegetableJuiceImage::onMount(%this,%obj,%slot)
{
   VegetableJuiceImage::onMount(%this,%obj,%slot);
}
function YellowVegetableJuiceImage::onUnMount(%this,%obj,%slot)
{
   VegetableJuiceImage::onUnMount(%this,%obj,%slot);
}
function Player::HideHead(%obj)
{
   %obj.hideNode("HeadSkin");
   %obj.hideNode("helmet");
   %obj.hideNode("pointyHelmet");
   %obj.hideNode("flareHelmet");
   %obj.hideNode("scoutHat");
   %obj.hideNode("bicorn");
   %obj.hideNode("copHat");
   %obj.hideNode("knitHat");
}